"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.katexPlug = void 0;
var Parser_1 = require("../../model/Parser");
var katex_1 = require("katex");
var token_1 = require("../../model/token/token");
exports.katexPlug = {
    code: "s-katex",
    parser: function (lines) {
        var parser = new Parser_1.Parser(0);
        var lineNum = 0;
        var line = lines[0];
        if (line !== "$$") {
            return parser;
        }
        var token = new token_1.BaseToken('s-katex');
        while (true) {
            lines.shift();
            lineNum++;
            if (lines.length === 0) {
                return parser;
            }
            var line_1 = lines[0];
            if (line_1.trim() === "$$") {
                lineNum++;
                break;
            }
            token.data += line_1;
        }
        parser.add(token);
        return parser.set(lineNum);
    },
    render: [
        {
            code: "s-katex",
            subParserType: [],
            render: function (t, _ctx, _tran) {
                var token = t;
                var html = '';
                html = (0, katex_1.renderToString)(token.data, {
                    displayMode: true,
                    throwOnError: false
                });
                return html;
            },
        }
    ]
};
//# sourceMappingURL=katex.js.map