"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var Parser_1 = require("../../model/Parser");
var quoteToken_1 = require("../../model/token/quoteToken");
var quoteUtil_1 = require("../../utils/quoteUtil");
describe('parser', function () {
    it('Should return greetings', function () {
        var list = [
            {
                a: ["adfsaf"],
                b: new Parser_1.Parser(0)
            },
        ];
        var parser = new Parser_1.Parser(2);
        var token = new quoteToken_1.QuoteToken('s-quote');
        token.data.push({
            typ: 1,
            data: 'aaa'
        });
        parser.add(token);
        list.push({
            a: ["> aaa\n            "],
            b: parser
        });
        var parser2 = new Parser_1.Parser(3);
        var token2 = new quoteToken_1.QuoteToken('s-quote');
        token2.data.push({
            typ: 1,
            data: 'aa'
        });
        token2.data.push({
            typ: 2,
            data: 'bb'
        });
        parser2.add(token2);
        list.push({
            a: ["> aa\n            >> bb\n            "],
            b: parser2
        });
        var parser22 = new Parser_1.Parser(3);
        var token22 = new quoteToken_1.QuoteToken('s-quote');
        token22.data.push({
            typ: 1,
            data: 'aa'
        });
        token22.data.push({
            typ: 1,
            data: 'bb'
        });
        parser22.add(token22);
        list.push({
            a: ["> aa\n            > bb\n            "],
            b: parser22
        });
        for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
            var v = list_1[_i];
            var d = (0, quoteUtil_1.quoteParser)(v.a);
            (0, chai_1.expect)(d).to.deep.equal(v.b);
        }
    });
});
describe('render', function () {
    it('Should return greetings', function () {
        console.log("");
    });
});
//# sourceMappingURL=quote.spec.js.map