"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.titlePlug = void 0;
var Parser_1 = require("../../model/Parser");
var token_1 = require("../../model/token/token");
exports.titlePlug = {
    code: "s-title",
    parser: function (lines) {
        var parser = new Parser_1.Parser(0);
        var line = lines[0];
        var reg = /^#+ /;
        if (!reg.test(line)) {
            return parser;
        }
        reg = /(^#+ )([\w\W]*)/;
        var exec = reg.exec(line);
        if (exec == null) {
            return parser;
        }
        var head = exec[1];
        var data = exec[2];
        var token = new token_1.BaseToken('s-title');
        token.typ = head.length - 1;
        token.data = data;
        parser.add(token);
        return parser.set(1);
    },
    render: [
        {
            code: "s-title",
            subParserType: [],
            render: function (t, _ctx, tran) {
                var token = t;
                var n = token.typ;
                var head = "<h" + n + '>';
                var end = "</h" + n + '>';
                return head + tran(token.data, token) + end;
            },
        }
    ]
};
//# sourceMappingURL=title.js.map