"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.imgParser = exports.imgRender = void 0;
var imgToken_1 = require("../model/token/imgToken");
var Parser_1 = require("../model/Parser");
var imgParser = function (lines) {
    var parser = new Parser_1.Parser(0);
    if (lines.length < 2) {
        return parser;
    }
    var line = lines[0];
    if (line !== "@img") {
        return parser;
    }
    var line2 = lines[1];
    if (line2.length < 5) {
        return parser;
    }
    var line3 = lines[1];
    if (line3.trim() === "") {
        return parser;
    }
    var token = new imgToken_1.ImgToken('s-img');
    var imgDto = new imgToken_1.ImgDto();
    imgDto.imgName = "a.jpg";
    imgDto.imgInfo = "";
    imgDto.imgUrl = line2;
    token.set('h', 'left');
    token.add(imgDto);
    parser.add(token);
    return parser.set(3);
};
exports.imgParser = imgParser;
var imgRender = function (token, _ctx, _tran) {
    var dire = token.imgDirection;
    var imgPos = token.imgPos;
    var arr = token.imgList;
    var html = '';
    var divDire = 'row';
    if (dire == 'v') {
        divDire = 'column';
    }
    html += "\n<div style=\"display: flex;align-items: center;flex-flow:  ".concat(divDire, " wrap ;justify-content:  ").concat(imgPos, "\" class=\"lram lram-img\">");
    for (var _i = 0, arr_1 = arr; _i < arr_1.length; _i++) {
        var item = arr_1[_i];
        if (item instanceof imgToken_1.ImgDto) {
            var imgName = item.imgName;
            var imgUrl = item.imgUrl;
            //img-info
            var imgInfo = item.imgInfo;
            var infoData = '';
            if (imgInfo != '') {
                var infoWidth = item.infoWidth;
                infoData += "\n    <div style=\"margin: 20px; width: ".concat(infoWidth, "px\">\n        <p class=\"lead\">").concat(imgInfo, "</p>\n    </div>\n");
            }
            var imgInfoPos = item.imgInfoPos;
            var zIndex = imgInfoPos.indexOf('.');
            var s = imgInfoPos.substring(0, zIndex);
            var imgInfoPosLR = 'row';
            if (s == 'left') {
                imgInfoPosLR = 'row-reverse';
            }
            var imgInfoPosUCD = imgInfoPos.substring(zIndex + 1, imgInfoPos.length);
            var imgStyle = genImgStyle(item);
            html += "\n<div style=\"flex: none; display: flex; align-items: ".concat(imgInfoPosUCD, "; flex-direction: ").concat(imgInfoPosLR, "\">\n    <figure class=\"figure\" \">\n        <img src=\"").concat(imgUrl, "\"\n             alt=\"").concat(imgName, "\"\n             style=\"").concat(imgStyle, "\"\n             class=\"figure-img img-fluid rounded\">\n        <figcaption class=\"figure-caption\">").concat(imgName, "</figcaption>\n    </figure>\n").concat(infoData, "\n</div>\n");
        }
        if (item instanceof imgToken_1.ImgSpaceDto) {
            for (var i = 0; i < item.num; i++) {
                html += '<div style="margin: 40px;"></div>';
            }
        }
        if (item instanceof imgToken_1.ImgGroupDto) {
            html += imgRender(item, _ctx, _tran);
        }
    }
    html += '</div>';
    return html;
};
exports.imgRender = imgRender;
var genImgStyle = function (v) {
    var imgStyle = '';
    if (v.colorPoint > 0) {
        var cp = (10 - v.colorPoint) / 10;
        imgStyle += "filter: grayscale(".concat(cp, ");");
    }
    if (v.height != 0 || v.width != 0) {
        if (v.height != 0) {
            imgStyle += "height: ".concat(v.height, "px;");
        }
        if (v.width != 0) {
            imgStyle += "width: ".concat(v.width, "px;");
        }
        return imgStyle;
    }
    if (v.selfPoint != 0) {
        imgStyle += "width: ".concat(v.selfPoint, "%;");
        return imgStyle;
    }
    if (v.winPoint != 0) {
        imgStyle += "width: ".concat(v.winPoint, "vw;");
        return imgStyle;
    }
    return imgStyle;
};
//# sourceMappingURL=imgUtil.js.map