"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListRenderFun = void 0;
var listToken_1 = require("../model/token/listToken");
var ListRenderFun = function (token, _ctx, _tran) {
    var typ = token.typ;
    var list = token.list;
    var html = '';
    var h = '';
    if (typ == '-') {
        html = "<ul>";
        h = "</ul>";
    }
    else {
        var typCla = genStyle(typ);
        html = "<ol style=\"list-style-type: ".concat(typCla, "\">");
        h = '</ol>';
    }
    for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
        var item = list_1[_i];
        if (item instanceof listToken_1.ListDto) {
            var len = html.length;
            html = html.substring(0, len - 5) + (0, exports.ListRenderFun)(item, _ctx, _tran) + html.substr(len - 5, 5);
        }
        else {
            html += "<li>".concat(item, "</li>");
        }
    }
    html += h;
    return html;
};
exports.ListRenderFun = ListRenderFun;
var genStyle = function (typ) {
    var style = '';
    switch (typ) {
        case "1":
            style = 'decimal';
            break;
        case "01":
            style = 'decimal-leading-zero';
            break;
        case "i":
            style = 'lower-roman';
            break;
        case "I":
            style = 'upper-roman';
            break;
        case "a":
            style = 'lower-alpha';
            break;
        case "A":
            style = 'upper-alpha';
            break;
        case "al":
            style = 'lower-greek';
            break;
        case "cn":
            style = 'cjk-ideographic';
            break;
        default:
            style = 'decimal';
    }
    return style;
};
//# sourceMappingURL=listRender.js.map