"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.listRender = exports.listParser = void 0;
var Parser_1 = require("../model/Parser");
var listToken_1 = require("../model/token/listToken");
var listParser = function (lines) {
    var parser = new Parser_1.Parser(0);
    var lineNum = 0;
    var line = lines[0];
    var reg = /^(-|1\.|01\.|a\.|A\.|i\.|I\.|cn\.|al\.)\s+(\S+)$/;
    var exec = reg.exec(line);
    if (exec == null) {
        return parser;
    }
    var typ = genTyp(exec[1]);
    var data = exec[2];
    var token = new listToken_1.ListToken('s-list');
    token.set(typ);
    token.add(data);
    while (true) {
        lines.shift();
        lineNum++;
        if (lines.length == 0) {
            parser.add(token);
            return parser.set(lineNum);
        }
        var line_1 = lines[0];
        //end
        if (line_1.trim() == '') {
            parser.add(token);
            return parser.set(lineNum + 1);
        }
        var reg_1 = /^(-|1\.|01\.|a\.|A\.|i\.|I\.|cn\.|al\.)\s+(\S+)$/;
        var exec_1 = reg_1.exec(line_1);
        if (exec_1 != null) {
            var data_1 = exec_1[2];
            token.add(data_1);
            continue;
        }
        var list = token.data.list;
        list[list.length - 1] += line_1;
    }
};
exports.listParser = listParser;
var listRender = function (token, _ctx, _tran) {
    var typ = token.typ;
    var list = token.list;
    var html = '';
    var h = '';
    if (typ == '-') {
        html = "<ul>";
        h = "</ul>";
    }
    else {
        var typCla = genStyle(typ);
        html = "<ol style=\"list-style-type: ".concat(typCla, "\">");
        h = '</ol>';
    }
    for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
        var item = list_1[_i];
        if (item instanceof listToken_1.ListDto) {
            var len = html.length;
            html = html.substring(0, len - 5) + listRender(item, _ctx, _tran) + html.substr(len - 5, 5);
        }
        else {
            html += "<li>".concat(item, "</li>");
        }
    }
    html += h;
    return html;
};
exports.listRender = listRender;
var genStyle = function (typ) {
    var style = '';
    switch (typ) {
        case "1":
            style = 'decimal';
            break;
        case "01":
            style = 'decimal-leading-zero';
            break;
        case "i":
            style = 'lower-roman';
            break;
        case "I":
            style = 'upper-roman';
            break;
        case "a":
            style = 'lower-alpha';
            break;
        case "A":
            style = 'upper-alpha';
            break;
        case "al":
            style = 'lower-greek';
            break;
        case "cn":
            style = 'cjk-ideographic';
            break;
        default:
            style = 'decimal';
    }
    return style;
};
var genTyp = function (str) {
    return str.replace('.', '');
};
//# sourceMappingURL=listUtil.js.map