"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tableParser = exports.tableRender = void 0;
var Parser_1 = require("../model/Parser");
var tableToken_1 = require("../model/token/tableToken");
var tableParser = function (lines) {
    var parser = new Parser_1.Parser(0);
    var lineNum = 0;
    var line = lines[0];
    var reg = /^\|([\s\S]*\|)+[\s\S]*$/;
    if (!reg.test(line)) {
        return parser;
    }
    //匹配table 第一行 成功
    reg = /[\s\S]*?\|/g;
    var oneLineHeadDatalist = line.split('|');
    oneLineHeadDatalist = oneLineHeadDatalist.slice(1, oneLineHeadDatalist.length - 1);
    var tableColNum = oneLineHeadDatalist.length;
    lines.shift();
    lineNum++;
    var twoLine = lines[0];
    reg = /^\|((\s*-\s*|\s*-:\s*|\s*:-\s*)\|)+\s*$/;
    //第二行匹配table，失败
    if (!reg.test(twoLine)) {
        //无法匹配table模式
        return parser;
    }
    //第二行匹配table成功，进入table模式
    var twoLineHeadDatalist = twoLine.split('|');
    twoLineHeadDatalist = twoLineHeadDatalist.slice(1, twoLineHeadDatalist.length - 1);
    var colType = [];
    for (var _i = 0, twoLineHeadDatalist_1 = twoLineHeadDatalist; _i < twoLineHeadDatalist_1.length; _i++) {
        var value = twoLineHeadDatalist_1[_i];
        switch (value.trim()) {
            case '-':
                colType.push(1);
                break;
            case ':-':
                colType.push(2);
                break;
            case '-:':
                colType.push(3);
                break;
            default:
                return parser;
        }
    }
    if (twoLineHeadDatalist.length !== tableColNum) {
        return parser;
    }
    var token = new tableToken_1.TableToken('s-table');
    token.colNum = tableColNum;
    token.colType = colType;
    token.rowNum = 1;
    // [][]string
    token.data[0] = oneLineHeadDatalist;
    while (true) {
        lines.shift();
        if (lineNum === 7) {
            throw '3';
        }
        lineNum++;
        if (lines.length === 0) {
            break;
        }
        line = lines[0];
        if (line.trim() === '') {
            break;
        }
        //table 3
        reg = /^\|([\s\S]*\|)+\s*$/;
        //第一行匹配table
        if (!reg.test(line)) {
            break;
        }
        token.data[token.rowNum] = [];
        var list = line.split('|');
        list = list.slice(1, list.length - 1);
        for (var i = 0; i < token.colNum; i++) {
            token.data[token.rowNum][i] = list[i];
        }
        token.rowNum++;
    }
    parser.add(token);
    return parser.set(lineNum);
};
exports.tableParser = tableParser;
var tableRender = function (token, _ctx, _tran) {
    var html = '';
    var colNum = token.colNum;
    var rowNum = token.rowNum;
    html += '<thead>';
    html += '<tr>';
    html += renderRow(token.data[0], colNum);
    html += '</tr>';
    html += '</thead>';
    html += '<tbody>';
    for (var i = 1; i < rowNum; i++) {
        html += '<tr>';
        html += renderRow(token.data[i], colNum);
        html += '</tr>';
    }
    html += '</tbody>';
    return '<table class="">' + html + '</table>';
};
exports.tableRender = tableRender;
function renderRow(rows, len) {
    var html = '';
    for (var k = 0; k < len; k++) {
        html += '<td>' + rows[k] + '</td>';
    }
    return html;
}
//# sourceMappingURL=tableUtil.js.map